{===================================================
CDMan  v.1 Delphi Source
(C) 2004 Copyright by Puzeyev Alexander
E-Mail: Ox5@mail.ru
Homepage: http://netstage.narod.ru
       
     .
        
  .
The source code can be used by you in the educational purposes
Or for use in the programs.
In any case inform me if at you it to turn out
something interesting.
====================================================}
program CDMan;
uses
  Windows,
  ShellAPI,
  Messages,
  MMSystem,
  io in 'io.pas';

{$R CDMan_i.res}

const
{$EXTERNALSYM NIF_INFO}
  NIF_INFO = $00000010;

  NIIF_NONE = $00000000;
  NIIF_INFO = $00000001;
  NIIF_WARNING = $00000002;
  NIIF_ERROR = $00000003;


  ClassName = 'CDMan'; {   }
  ClassName2 = 'WebLabel'; {   }
  WM_NOTIFYTRAYICON = WM_USER + 1; {        tray }
  base_hotkey_id = $1000;
  MAX_CD_COUNT = 8;

var
  menu: hMenu; {   }
  cd_count: byte; {  CD-ROM'   10}
  cds: array[1..24] of char;
  cd_op: array[1..24] of boolean; {   cd-rom'a, true- }
  i: byte;
  tray: TNotifyIconData;

  win_h, win_w: word;
  btn1, lbl1, lbl2, lbl3, lbl4: hwnd;
  BalloonTime: word;
  { static standart structure}
  st_lc: WndClass;
  stWNDproc: Pointer = nil;
  hDC_s: HDC;

function TextWidth(s_text: string): TSize;
begin
  Result.cx := 0;
  Result.cy := 0;
  GetTextExtentPoint32(GetDc(mywnd), PChar(s_text), Length(s_text), result);
end;

procedure ShowBalloon(titletext: string; textinfo: string; dwIF: dword);
begin
  {initialize the structure to include the necessary information for
  displaying balloon tooltips}
  tray.uFlags := tray.uFlags or NIF_INFO;
  Strpcopy(tray.szInfo, textinfo);
  tray.uTimeout := BalloonTime;
  Strpcopy(tray.szInfoTitle, titletext);
  tray.dwInfoFlags := dwIF;
  {display the balloon tooltip}
  Shell_NotifyIcon(NIM_MODIFY, @tray);
  tray.szInfo := '';
  tray.szInfoTitle := '';
  tray.dwInfoFlags := 0;
end;

procedure ModifyTray(ic: Hicon);
begin
  tray.hIcon := ic;
  if tray.hicon = 0 then messagebox(mywnd, '     .', '!', MB_ICONWARNING or MB_OK);

  Shell_NotifyIcon(NIM_MODIFY, @tray);
end;

function OpenCD(Drive: Char): Boolean;
var
  Res: MciError;
  OpenParm: TMCI_Open_Parms;
  Flags: DWord;
  S: string;
  DeviceID: Word;
begin
  Result := false;
  S := Drive + ':';
  Flags := mci_Open_Type or mci_Open_Element;

  with OpenParm do
  begin
    dwCallback := 0;
    lpstrDeviceType := 'CDAudio';
    lpstrElementName := PChar(S);
  end;

  Res := mciSendCommand(0, mci_Open, Flags, Longint(@OpenParm));
  if Res <> 0 then exit;
  DeviceID := OpenParm.wDeviceID;
  try
    Res := mciSendCommand(DeviceID, MCI_SET, MCI_SET_DOOR_OPEN, 0);
    if Res = 0 then exit; Result := True;
  finally
    mciSendCommand(DeviceID, mci_Close, Flags, Longint(@OpenParm));
  end;
end;

function CloseCD(Drive: Char): Boolean;
var
  Res: MciError;
  OpenParm: TMCI_Open_Parms;
  Flags: DWord;
  S: string;
  DeviceID: Word;
begin
  Result := false;
  S := Drive + ':';
  Flags := mci_Open_Type or mci_Open_Element;
  with OpenParm do
  begin
    dwCallback := 0;
    lpstrDeviceType := 'CDAudio';
    lpstrElementName := PChar(S);
  end;
  Res := mciSendCommand(0, mci_Open, Flags, Longint(@OpenParm));
  if Res <> 0 then exit;
  DeviceID := OpenParm.wDeviceID;
  try
    Res := mciSendCommand(DeviceID, MCI_SET, MCI_SET_DOOR_CLOSED, 0);
    if Res = 0 then exit;
    Result := True;
  finally
    mciSendCommand(DeviceID, mci_Close, Flags, Longint(@OpenParm));
  end;
end;

function MyLblWndProc(wnd: hWnd; msg, wParam,
  lParam: longint): longint; stdcall;
begin
  case msg of
    wm_LButtonDown:
      begin
        messagebox(mywnd, ' ', 'error', mb_ok);
      end;
  else Result := CallWindowProc(stWNDproc, wnd, msg, wparam, lparam);
  end;
end;

function MyWndProc(wnd: hWnd; msg, wParam,
  lParam: longint): longint; stdcall;
var
  p: TPoint;
  tray: TNotifyIconData;
  hdc_f: hDC;
  ps: tagPAINTSTRUCT;
  br_new: HBrush;
  br_old: HBrush;
begin
  result := 0;
  case msg of
    WM_NOTIFYTRAYICON: begin {  tray }
      {    ,  : }
        if lparam = WM_RBUTTONUP then
        begin
          GetCursorPos(p);
          TrackPopupMenu(menu, TPM_LEFTALIGN, p.x, p.y, 0, wnd, nil);
        end;
        result := 0;
      end;
    WM_CTLCOLORSTATIC:
      begin
        if (lparam = lbl1) or (lparam = lbl2) or (lparam = lbl4) then
        begin
          SetTextColor(wparam, RGB(0, 0, 255));
          SetBkColor(wparam, GetSysColor(COLOR_BTNFACE));
          result := wparam;
        end;
      end;
    WM_COMMAND: {    }
      begin
      {     -      : }
        case lo(wparam) of
          0: begin
              SendMessage(mywnd, WM_CLOSE, 0, 0);
              result := 0;
            end;
         {  }
          1: begin
              if GetMenuState(menu, lo(wparam), MF_BYCOMMAND) = mf_unchecked then
              begin
          {   }
                AutoRun(true);
                CheckMenuItem(menu, 1, MF_BYCOMMAND or MF_CHECKED)
              end
              else
              begin
          {   }
                AutoRun(false);
                CheckMenuItem(menu, 1, MF_UNCHECKED or MF_BYCOMMAND);
              end;
            end;
          2: begin
              showwindow(mywnd, SW_SHOW);
            end;
          11..35: begin
              ModifyTray(LoadIcon(0, idi_winlogo));
              if not cd_op[lo(wparam) - 10] then
              begin
                if ShowBalloon_key = 1 then ShowBalloon('CDMan', 'CDROM ' +
                    UpCase(cds[lo(wparam) - 10]) + ': -  ', NIIF_INFO);
                Opencd(cds[lo(wparam) - 10])
              end
              else
              begin
                if ShowBalloon_key = 1 then ShowBalloon('CDMan', 'CDROM ' +
                    UpCase(cds[lo(wparam) - 10]) + ': -  ', NIIF_INFO);
                Closecd(cds[lo(wparam) - 10]);
              end;
              cd_op[lo(wparam) - 10] := not cd_op[lo(wparam) - 10];
              ModifyTray(ExtractIcon(hInstance, PChar(Paramstr(0)), 0));
            end;
          100: begin
              showwindow(mywnd, SW_HIDE);
            end;
        end;
      end;
    WM_PAINT:
      begin
        hDC_f := BeginPaint(myWnd, ps);
        DrawIcon(hDC_f, 5, 5, ExtractIcon(hInstance, PChar(Paramstr(0)), 0));
        EndPaint(myWnd, ps);
      end;
    WM_KEYDOWN:
      begin
        if (wparam = VK_SPACE) or (wparam = VK_RETURN) or (wparam = VK_ESCAPE) then showwindow(mywnd, SW_HIDE);
      end;
    WM_HOTKEY: begin {    }
        ModifyTray(LoadIcon(0, idi_winlogo));
        if not cd_op[lo(wparam)] then
        begin
          if ShowBalloon_key = 1 then ShowBalloon('CDMan', 'CDROM ' +
              UpCase(cds[lo(wparam)]) + ': -  ', NIIF_INFO);
          Opencd(cds[lo(wparam)])
        end
        else
        begin
          if ShowBalloon_key = 1 then ShowBalloon('CDMan', 'CDROM ' +
              UpCase(cds[lo(wparam)]) + ': -  ', NIIF_INFO);
          Closecd(cds[lo(wparam)]);
        end;
        cd_op[lo(wparam)] := not cd_op[lo(wparam)];
        result := 0;
        ModifyTray(ExtractIcon(hInstance, PChar(Paramstr(0)), 0));
      end;
    WM_DESTROY: begin {   }
       {  tray: }
        with tray do begin
          cbSize := sizeof(TNotifyIconData);
          wnd := mywnd;
          uID := 0;
        end;
        Shell_NotifyIcon(NIM_DELETE, @tray);
        ReleaseDC(mywnd, hdc_s); // 
        PostQuitMessage(0);
        result := 0;
      end;
  else Result := DefWindowProc(wnd, msg, WParam, LParam);
  end;
end;

procedure CreateLabel;
var
  fnt, oldfnt: HFont;

  lf: LOGFONT;
  lc: WndClass;
begin


  lbl1 := CreateWindowEx(0, 'static_web', 'CDMan v. 0.1', ws_child or ws_visible or ws_tabstop,
    46, 5, 66, 13, myWnd, 0, hInstance, nil);

  lbl2 := CreateWindowEx(0, 'static', 'http://netstage.narod.ru', ws_child or ws_visible or ws_tabstop,
    46, 23, 90, 15, myWnd, 0, hInstance, nil);

  lbl3 := CreateWindowEx(0, 'static', 'E-mail:', ws_child or ws_visible or ws_tabstop,
    38, 41, 60, 30, myWnd, 0, hInstance, nil);

  lbl4 := CreateWindowEx(0, 'static', 'Ox5@mail.ru', ws_child or ws_visible or ws_tabstop,
    72, 41, 67, 13, myWnd, 0, hInstance, nil);

  btn1 := CreateWindowEx(0, 'button', 'OK', bs_pushbutton or bs_defpushbutton or ws_child or ws_visible or ws_tabstop,
    46, 60, 75, 25, myWnd, 100, hInstance, nil);


  SendMessage(lbl1, WM_SETFONT, GetStockObject(DEFAULT_GUI_FONT), 0);
  SendMessage(lbl2, WM_SETFONT, GetStockObject(DEFAULT_GUI_FONT), 0);
  SendMessage(lbl3, WM_SETFONT, GetStockObject(DEFAULT_GUI_FONT), 0);
  SendMessage(lbl4, WM_SETFONT, GetStockObject(DEFAULT_GUI_FONT), 0);
  SendMessage(btn1, WM_SETFONT, GetStockObject(DEFAULT_GUI_FONT), 0);


  hdc_s := GetDC(mywnd); //  
  lf.lfHeight := -30; {   ,    ,
            ,   :
    lf.lfHeight := MulDiv(PointSize, GetDeviceCaps(dc, LOGPIXELSY), 72);}
  lf.lfHeight := MulDiv(10, GetDeviceCaps(hdc_s, LOGPIXELSY), 72);
// 				lf.lfHeight := 10;
  lf.lfWidth := 0; // 
  lf.lfEscapement := 0; //   - 9    X 
  lf.lfOrientation := 0;
  lf.lfWeight := 400; // 
  lf.lfItalic := 0;
  lf.lfUnderline := 1;
  lf.lfStrikeOut := 0;
  lf.lfCharSet := RUSSIAN_CHARSET;
  lf.lfOutPrecision := 0;
  lf.lfClipPrecision := 0;
  lf.lfQuality := ANTIALIASED_QUALITY;
  lf.lfFaceName := 'Ms Sans Serif'; //  


  fnt := CreateFontIndirect(lf); // 

  oldFnt := SelectObject(hdc_s, fnt); //   

  SetBkMode(hdc_s, TRANSPARENT); //    

  SendMessage(lbl1, WM_SETFONT, fnt, 0);
  SendMessage(lbl2, WM_SETFONT, fnt, 0);
  SendMessage(lbl4, WM_SETFONT, fnt, 0);

  SelectObject(hdc_s, oldFnt); //    

end;

function CreateMyWnd: hWnd;
var
  wc: WndClass;
begin
  {  : }
  wc.style := cs_hredraw or cs_vredraw;
  wc.lpfnWndProc := @MyWndProc;
  wc.cbClsExtra := 0;
  wc.cbWndExtra := 0;
  wc.hInstance := hInstance;
  wc.hIcon := ExtractIcon(hInstance, PChar(Paramstr(0)), 0);
  wc.hCursor := LoadCursor(0, IDC_ARROW);
  wc.hbrBackground := COLOR_WINDOW;
  wc.lpszMenuName := nil;
  wc.lpszClassName := ClassName;
  if RegisterClass(wc) = 0 then halt(0);
  {  : }
  result := CreateWindow(ClassName, 'CDMan',
    WS_OVERLAPPED or WS_BORDER, (GetSystemMetrics(SM_CXSCREEN) - win_w) div 2,
    (GetSystemMetrics(SM_CYSCREEN) - win_h) div 2, win_w, win_h, 0, 0, hInstance, nil);
  if result = 0 then halt(0);
end;

procedure CreateTray;
begin
  tray.cbSize := sizeof(TNotifyIconData);
  tray.Wnd := mywnd;
  tray.uID := 0;
  tray.uFlags := NIF_ICON or NIF_MESSAGE or NIF_TIP;
  tray.uCallbackMessage := WM_NOTIFYTRAYICON;
  tray.hIcon := ExtractIcon(hInstance, PChar(Paramstr(0)), 0);

  if tray.hIcon = 0 then messagebox(mywnd, '     .', '', MB_ICONWARNING or MB_OK);
  tray.szTip := 'CDMan v. 0.1';

  Shell_NotifyIcon(NIM_ADD, @tray);

end;

function CreateMyMenu: hMenu;
var
  disc_char: char;
begin
  cd_count := 0;
  {  : }
  result := CreatePopupMenu;
  if result = 0 then halt(0);
  for disc_char := 'A' to 'Z' do
    if GetDriveType(PChar(disc_char + ':\')) = DRIVE_CDROM then
    begin
      inc(cd_count);
      cds[cd_count] := disc_char;
      if cd_count <= MAX_CD_COUNT then
      begin
        if not AppendMenu(result, MF_STRING, 10 + cd_count,
//     PChar(IntToStr(cd_count)+'. '+disc_char+':\'+'  >>  CD-ROM ')) then halt(0);
          PChar(IntToStr(cd_count) + '.   ' + disc_char + ':\')) then halt(0);
      end
      else
        cd_count := MAX_CD_COUNT;
    end;

  if not AppendMenu(result, MF_SEPARATOR, 0, ' ') then halt(0);
  if not AppendMenu(result, MF_CHECKED, 1, '&') then halt(0);
  if not AppendMenu(result, MF_SEPARATOR, 0, ' ') then halt(0);
  if not AppendMenu(result, MF_STRING, 2, ' &') then halt(0);
  if not AppendMenu(result, MF_STRING, 0, '&') then halt(0);

  if ShowBalloon_key = 1 then ShowBalloon('CDMan', ' ' + Inttostr(cd_count) + '  CD-ROM''', NIIF_INFO);
end;
{   }

function IntToChar(it: byte): Char;
var
  st: string;
begin
  st := IntToStr(it);
  result := st[1];
end;
label ls;
var
  msg: TMsg;
  cdl: char;
begin
  win_h := 120;
  win_w := 170;
  BalloonTime := 2000;
  if paramcount > 0 then
    case paramcount of
      1: begin
          if UpCaseStr(paramstr(1)) = '/HELP' then
            messagebox(mywnd, 'CDMan v. 0.1', 'Help', MB_ICONINFORMATION or mb_ok);
          halt(0);
        end;
      2: begin
          cdl := UpCase(paramstr(2)[1]);
          if ((cdl) >= 'A') and
            ((cdl) <= 'Z') then
          begin
            if (UpCaseStr(paramstr(1)) = '/O') then OpenCD(cdl);
            if (UpCaseStr(paramstr(1)) = '/C') then CloseCD(cdl);
          end;
          halt(0);
        end;
    end;

  if not FileExists(Config_File) then WriteDefCFQ;

  LoadCFG;

  //  
  mywnd := CreateMyWnd;
  CreateLabel;

  showwindow(mywnd, SW_SHOW);

  //  
  if TrayIcon_key = 1 then
    CreateTray;
  //  
  if TrayIcon_key = 1 then
    menu := CreateMyMenu;
  {    }
  SetThreadPriority(GetCurrentThread, THREAD_PRIORITY_IDLE);
   //  " "
  for i := 1 to cd_count do
  begin
    if not RegisterHotKey(mywnd, base_hotkey_id + i, MOD_CONTROL, Ord(IntToChar(i))) then
      messagebox(mywnd, '    !' + #13 + #10 +
        '      .', '!', MB_ICONWARNING or MB_OK);
    cd_op[i] := false;
  end;


  while (GetMessage(msg, 0, 0, 0)) do
  begin
    TranslateMessage(msg);
    DispatchMessage(msg);
  end;
  UnregisterHotKey(mywnd, 0); // ""  
  WriteCFQ;
  asm
   jmp ls;
   db '+----------------------------+';
   db '|                            |';
   db '|                            |';
   db '|                            |';
   db '|                            |';
   db '|                            |';
   db '| CDMan v. 0.1               |';
   db '| (C)2004, Puzeyev Alexander |';
   db '| e-mail: ox5@mail.ru        |';
   db '| www: netstage.narod.ru     |';
   db '|                            |';
   db '|                            |';
   db '|                            |';
   db '|                            |';
   db '|                            |';
   db '+----------------------------+';
   ls:
  end;
end.
